题干:
链接:https://ac.nowcoder.com/acm/contest/886/J?&headNav=acm&headNav=acm&headNav=acm&headNav=acm
来源:牛客网
Rowlet is playing a very popular game in the pokemon world. Recently, he has encountered a problem and wants to ask for your help.
In this game, there is a technology tree system. There are n kinds of technology in this game, each of them has m levels numbered from 1 to m. In the beginning, all technologies have no level (regard as level 0). When the i-th technology is at the (j - 1)-th level, the player can pay cijc_{i j}cij pokedollars (currency used in this game) to upgrade this technology into the j-th level. However, sometimes upgrading is so easy that the cost might be negative, which implies the player may gain profit from upgrading technologies.
Moreover, if all technologies have been upgraded to level j, the player will gain an additional profit of djd_{j}dj pokedollars. However, sometimes too many technologies of the same level might be confusing, hence the profit can be negative as well.
Rowlet wants to determine the optimal strategy that can bring him the most pokedollars. Help him to find the maximum gain. Note that Rowlet may upgrade nothing, and in that case, the profit is zero.
输入描述:
There are multiple test cases. The first line contains an integer T (1≤T≤101 \leq T \leq 101≤T≤10), indicating the number of test cases. Test cases are given in the following.For each test case, the first line contains two integers n, m (1≤n,m≤10001 \leq n, m \leq 10001≤n,m≤1000), representing the number of technologies and the number of levels respectively.The i-th of the next n lines contains m integers, where the j-th number is cijc_{i j}cij (−109≤cij≤109-10^{9} \leq c_{i j} \leq 10^{9}−109≤cij≤109).The last line contains m integers, where the j-th number is djd_{j}dj (−109≤dj≤109-10^{9} \leq d_{j} \leq 10^{9}−109≤dj≤109).We ensure that the sum of n⋅mn \cdot mn⋅m in all test cases is at most 2×1062 \times 10^{6}2×106.
输出描述:
For each test case, output "Case #x: y" in one line (without quotes), where x indicates the case number starting from 1, and y denotes the answer(in pokedollars) to this test case.
示例1
输入
复制
2
2 2
1 2
2 -1
4 1
3 3
1 2 3
1 2 3
1 2 3
6 7 8
输出
复制
Case #1: 2
Case #2: 4
说明
In the first example, Rowlet can upgrade the first technology to level 1 and the second technology to level 2, which costs 1 + 2 - 1 = 2 pokedollars, but Rowlet can get 4 pokedollars as the bonus of upgrading all technologies to level 1, so the answer is 4 - 2 = 2 pokedollars.
In the second example, Rowlet can upgrade all technologies to level 2, which costs 1×3+2×3=91\times3 + 2\times3=91×3+2×3=9 pokedollars, but Rowlet can get 6 pokedollars as the bonus of upgrading all technologies to level 1 and 7 pokedollars as the bonus of upgrading all technologies to level 2, so the answer is 6 + 7 - 9 = 4 pokedollars.
题目大意:
就是给你n个技能,每个技能最高升到m级,只能从下往上连续的点技能(n*m矩阵)每升一级就是耗费Cij钱,这个Cij可能是负的,如果所有技能都升到或者说超过j等级,就会获得Dj钱,这个Dj也有可能是负值,让你求你最多得到多少钱(技能没有固定说要升到多少级,你也可以不升,这样就获得了0)
解题报告:
直接枚举最小等级的做法我们就不介绍了哈,比较简单,,而且其实不用线段树求后缀最小值的。直接可以预处理出来后缀最小值,然后直接取就可以,时间复杂度是O(n*m)的。
这里说另外一种dp方式:
dp[i][j]代表前i个技能升级到最小等级是j 的最大收益。根据这个最小等级j是否来自第i个技能,显然有转移方程:
dp[i][j]=max(①,②)
①dp[i-1][j]+第i行的max[j,m] ②前i-1行的max[j,m] + 第i行的sum[j]。
当然如果这样做的话,需要再用dp预处理一个东西dd[][]数组,dd[i][j]代表前i个物品只能取后j种等级,且每种科技中只能取一个值的最小收益(但因为给定的值的含义是花费,所以可以认为是给定数据的最大值)。
然后几个细节注意一下就好了。比如ans不能在dp的过程中取(这是个废话,,麻瓜错误)。再比如 i==1 的时候要跳过②那种情况。其实活着直接i==1的时候特殊处理一下就行。再比如suf[][m+1]必须要初始化,就跟前缀和数组一样只不过平时sum[0]=0了所以没管。
AC代码:
#include<cstdio>
#include<iostream>
#include<algorithm>
#include<queue>
#include<map>
#include<vector>
#include<set>
#include<string>
#include<cmath>
#include<cstring>
#define FF first
#define SS second
#define ll long long
#define pb push_back
#define pm make_pair
using namespace std;
typedef pair<int,int> PII;
const int MAX = 1e3 + 5;
int n,m;
ll a[MAX][MAX],suf[MAX][MAX],d[MAX],sum[MAX][MAX];
ll dd[MAX][MAX];
ll dp[MAX][MAX];//dp[i][j]代表前i个树,最小等级是j的最大收益。
int main()
{int t,iCase=0;cin>>t;while(t--) {scanf("%d%d",&n,&m);for(int i = 1; i<=n; i++) {for(int j = 1; j<=m; j++) scanf("%lld",&a[i][j]),suf[i][j] = 0,sum[i][j] = sum[i][j-1] + a[i][j];}for(int i = 1; i<=n; i++) {ll tmp = 0;suf[i][m+1] = 0;for(int j = m; j>=1; j--) tmp += a[i][j],suf[i][j] = max(suf[i][j+1],tmp);}ll ans = 0;for(int i = 1; i<=m; i++) scanf("%lld",d+i),d[i] += d[i-1];for(int i = 1; i<=n; i++) {for(int j = 1; j<=m+1; j++) {dd[i][j] = dd[i-1][j] + sum[i][m] - suf[i][j];}}for(int i = 1; i<=n; i++) {for(int j = 0; j<=m; j++) {//别忘考虑j==0的情况//如果第i个是j等级的话,那前i-1个可以随便取ll tmp = -sum[i][j] + d[j];tmp -= dd[i-1][j+1];//for(int k = 1; k<=i-1; k++) tmp -= sum[k][m] - suf[k][j+1];dp[i][j] = tmp;if(i == 1) continue;dp[i][j] = max(tmp,dp[i-1][j] - (sum[i][m] - suf[i][j+1]));
// ans = max(ans,dp[i][j]);}}for(int i = 0; i<=m; i++) ans = max(ans,dp[n][i]);printf("Case #%d: %lld\n",++iCase,ans);}return 0 ;
}
/*
1
2 2
-1 -1
-1 -1
-4 -4
*/